'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var Resizable = function Resizable(el, header, onResizing, onStartResizing, onStopResizing) {
  onResizing = onResizing ? onResizing : function () {
    return;
  };
  onStartResizing = onStartResizing ? onStartResizing : function () {
    return;
  };
  onStopResizing = onStopResizing ? onStopResizing : function () {
    return;
  };

  var opts = header.props.resizeOptions;
  if (el.className.indexOf('resizable') === -1) {
    return;
  }
  var resizable = el;
  var resizer = resizable.querySelector('.resizer');

  var startX = undefined;
  var stopX = undefined;
  var startWidth = undefined;
  var stopWidth = undefined;

  var doDrag = function doDrag(e) {
    var newWidth = startWidth + e.clientX - startX;
    if (opts.minWidth && newWidth < opts.minWidth || opts.maxWidth && newWidth > opts.maxWidth) {
      return;
    }
    resizable.style.width = newWidth + 'px';
    onResizing(e, newWidth);
  };

  var stopDrag = function stopDrag(e) {
    stopX = e.clientX;
    stopWidth = parseInt(document.defaultView.getComputedStyle(resizable).width, 10);
    document.documentElement.removeEventListener('mousemove', doDrag, false);
    document.documentElement.removeEventListener('mouseup', stopDrag, false);
    onStopResizing(e, stopX, stopWidth);
  };

  var initDrag = function initDrag(e) {
    startX = e.clientX;
    startWidth = parseInt(document.defaultView.getComputedStyle(resizable).width, 10);
    document.documentElement.addEventListener('mousemove', doDrag, false);
    document.documentElement.addEventListener('mouseup', stopDrag, false);
    onStartResizing(e, startX, startWidth);
  };

  resizer.addEventListener('mousedown', initDrag, false);
};

exports['default'] = Resizable;
module.exports = exports['default'];